diff -Nrc3pad libdvdcss/Makefile.os2 libdvdcss.os2/Makefile.os2
*** libdvdcss/Makefile.os2	Thu Jan  1 00:00:00 1970
--- libdvdcss.os2/Makefile.os2	Sat Jun 22 18:54:52 2002
***************
*** 0 ****
--- 1,51 ----
+ ###############################################################################
+ # Required compilers + tools:
+ #    IBM VisualAge C/C++ 3.6 ( 3.0/4 not tested )
+ #    IBM OS/2 developer's Toolkit 4.5 or later
+ #
+ # Build dvdcss.dll:
+ #    nmake -f Makefile.os2 /a
+ #
+ # Clean:
+ #    nmake -f Makefile.os2 clean
+ #
+ # OS/2 port by Alex Strelnikov <lelik@os2.ru>
+ ###############################################################################
+ 
+ CC = icc
+ LINK = ilink
+ 
+ OBJ_C = src\libdvdcss.obj src\css.obj src\ioctl.obj
+ 
+ CFLAGS = /Q -I. /O /Ge- /Ms /W0
+ LFLAGS = /nologo /nodebug /ex:2
+ 
+ .c.obj:
+     $(CC) -c $(CFLAGS) /Fo$* $<
+ 
+ LIB_CSS = dvdcss.dll
+ 
+ all: config.h $(LIB_CSS)
+ 
+ config.h:
+     echo #define SYS_OS2  1                            > $*.h
+     echo #define DVD_STRUCT_IN_BSDI_DVDIOCTL_DVD_H  1 >> $*.h
+     echo #define inline   __inline                    >> $*.h
+     echo #define VERSION  "1.2.1"                     >> $*.h
+ 
+ dvdcss.def:
+     echo LIBRARY DVDCSS INITINSTANCE TERMINSTANCE >  $*.def
+     echo DATA MULTIPLE NONSHARED                  >> $*.def
+     echo EXPORTS                                  >> $*.def
+     echo    dvdcss_open    @1                     >> $*.def
+     echo    dvdcss_close   @2                     >> $*.def
+     echo    dvdcss_title   @3                     >> $*.def
+     echo    dvdcss_seek    @4                     >> $*.def
+     echo    dvdcss_read    @5                     >> $*.def
+     echo    dvdcss_error   @6                     >> $*.def
+ 
+ $(LIB_CSS): $(OBJ_C) dvdcss.def
+     $(LINK) $(LFLAGS) -out:$@ $**
+ 
+ clean:
+     -@del $(OBJ_C) *.h *.def *.dll
diff -Nrc3pad libdvdcss/src/common.h libdvdcss.os2/src/common.h
*** libdvdcss/src/common.h	Sat Dec 22 03:08:12 2001
--- libdvdcss.os2/src/common.h	Sat Jun 22 18:53:10 2002
*************** typedef __int64 off_t;
*** 88,90 ****
--- 88,95 ----
  
  #endif
  
+ #if defined ( SYS_OS2 )
+ #   ifndef snprintf
+ #       define snprintf(str,num,fmt,args) sprintf(str,fmt,##args)
+ #   endif
+ #endif
diff -Nrc3pad libdvdcss/src/ioctl.c libdvdcss.os2/src/ioctl.c
*** libdvdcss/src/ioctl.c	Tue Jun  4 10:10:06 2002
--- libdvdcss.os2/src/ioctl.c	Sat Jun 22 16:13:28 2002
***************
*** 39,44 ****
--- 39,51 ----
  #if defined( WIN32 )
  #   include <windows.h>
  #   include <winioctl.h>
+ #elif defined ( SYS_OS2 )
+ #   define INCL_DOSFILEMGR
+ #   define INCL_DOSDEVICES
+ #   define INCL_DOSDEVIOCTL
+ #   define INCL_DOSERRORS
+ #   include <os2.h>
+ #   include <sys/ioctl.h>
  #else
  #   include <netinet/in.h>
  #   include <sys/ioctl.h>
*************** static void QNXInitCPT ( CAM_PASS_THRU *
*** 121,126 ****
--- 128,140 ----
  #endif
  
  /*****************************************************************************
+  * Local prototypes, OS2 specific
+  *****************************************************************************/
+ #if defined( SYS_OS2 )
+ static void OS2InitSDC( struct OS2_ExecSCSICmd *, int );
+ #endif
+ 
+ /*****************************************************************************
   * ioctl_ReadCopyright: check whether the disc is encrypted or not
   *****************************************************************************/
  int ioctl_ReadCopyright( int i_fd, int i_layer, int *pi_copyright )
*************** int ioctl_ReadCopyright( int i_fd, int i
*** 251,256 ****
--- 265,282 ----
  
      *pi_copyright = p_buffer[4];
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_READ_DVD_STRUCTURE, 8 );
+ 
+     sdc.command[ 6 ] = i_layer;
+     sdc.command[ 7 ] = DVD_STRUCT_COPYRIGHT;
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     *pi_copyright = p_buffer[ 4 ];
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReadDiscKey( int i_fd, int *pi
*** 407,412 ****
--- 433,455 ----
  
      memcpy( p_key, p_buffer + 4, DVD_DISCKEY_SIZE );
  
+ #elif defined ( SYS_OS2 )
+     INIT_SSC( GPCMD_READ_DVD_STRUCTURE, DVD_DISCKEY_SIZE + 4 );
+ 
+     sdc.command[ 7 ]  = DVD_STRUCT_DISCKEY;
+     sdc.command[ 10 ] = *pi_agid << 6;
+     
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     if( i_ret < 0 )
+     {
+         return i_ret;
+     }
+ 
+     memcpy( p_key, p_buffer + 4, DVD_DISCKEY_SIZE );
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReadTitleKey( int i_fd, int *p
*** 555,560 ****
--- 598,618 ----
  
      memcpy( p_key, p_buffer + 5, DVD_KEY_SIZE );
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 12 );
+ 
+     sdc.command[ 2 ] = ( i_pos >> 24 ) & 0xff;
+     sdc.command[ 3 ] = ( i_pos >> 16 ) & 0xff;
+     sdc.command[ 4 ] = ( i_pos >>  8 ) & 0xff;
+     sdc.command[ 5 ] = ( i_pos       ) & 0xff;
+     sdc.command[ 10 ] = DVD_REPORT_TITLE_KEY | (*pi_agid << 6);
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     memcpy( p_key, p_buffer + 5, DVD_KEY_SIZE );
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReportAgid( int i_fd, int *pi_
*** 668,673 ****
--- 726,742 ----
  
      *pi_agid = p_buffer[ 7 ] >> 6;
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 8 );
+ 
+     sdc.command[ 10 ] = DVD_REPORT_AGID | (*pi_agid << 6);
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     *pi_agid = p_buffer[ 7 ] >> 6;
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReportChallenge( int i_fd, int
*** 791,796 ****
--- 860,876 ----
  
      memcpy( p_challenge, p_buffer + 4, DVD_CHALLENGE_SIZE );
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 16 );
+ 
+     sdc.command[ 10 ] = DVD_REPORT_CHALLENGE | (*pi_agid << 6);
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     memcpy( p_challenge, p_buffer + 4, DVD_CHALLENGE_SIZE );
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReportASF( int i_fd, int *pi_r
*** 913,918 ****
--- 993,1009 ----
  
      *pi_asf = p_buffer[ 7 ] & 1;
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 8 );
+ 
+     sdc.command[ 10 ] = DVD_REPORT_ASF;
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     *pi_asf = p_buffer[ 7 ] & 1;
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReportKey1( int i_fd, int *pi_
*** 1031,1036 ****
--- 1122,1138 ----
  
      memcpy( p_key, p_buffer + 4, DVD_KEY_SIZE );
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 12 );
+ 
+     sdc.command[ 10 ] = DVD_REPORT_KEY1 | (*pi_agid << 6);
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     memcpy( p_key, p_buffer + 4, DVD_KEY_SIZE );
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_InvalidateAgid( int i_fd, int 
*** 1130,1135 ****
--- 1232,1249 ----
  
      i_ret = devctl(i_fd, DCMD_CAM_PASS_THRU, p_cpt, structSize, NULL);
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 1 );
+ 
+     sdc.data_length = 0;
+     sdc.command[ 8 ] = 0;
+     sdc.command[ 9 ] = 0;
+ 
+     sdc.command[ 10 ] = DVD_INVALIDATE_AGID | (*pi_agid << 6);
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         NULL, 0, &ulDataLen);
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_SendChallenge( int i_fd, int *
*** 1255,1260 ****
--- 1369,1386 ----
  
      i_ret = devctl(i_fd, DCMD_CAM_PASS_THRU, p_cpt, structSize, NULL);
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_SEND_KEY, 16 );
+ 
+     sdc.command[ 10 ] = DVD_SEND_CHALLENGE | (*pi_agid << 6);
+ 
+     p_buffer[ 1 ] = 0xe;
+     memcpy( p_buffer + 4, p_challenge, DVD_CHALLENGE_SIZE );
+ 
+     return DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                        &sdc, sizeof(sdc), &ulParamLen,
+                        p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_SendKey2( int i_fd, int *pi_ag
*** 1380,1385 ****
--- 1506,1523 ----
  
      i_ret = devctl(i_fd, DCMD_CAM_PASS_THRU, p_cpt, structSize, NULL);
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_SEND_KEY, 12 );
+ 
+     sdc.command[ 10 ] = DVD_SEND_KEY2 | (*pi_agid << 6);
+ 
+     p_buffer[ 1 ] = 0xa;
+     memcpy( p_buffer + 4, p_key, DVD_KEY_SIZE );
+ 
+     return DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                        &sdc, sizeof(sdc), &ulParamLen,
+                        p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** int ioctl_ReportRPC( int i_fd, int *p_ty
*** 1524,1529 ****
--- 1662,1680 ----
      *p_mask = p_buffer[ 5 ];
      *p_scheme = p_buffer[ 6 ];
  
+ #elif defined( SYS_OS2 )
+     INIT_SSC( GPCMD_REPORT_KEY, 8 );
+ 
+     sdc.command[ 10 ] = DVD_REPORT_RPC;
+ 
+     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
+                         &sdc, sizeof(sdc), &ulParamLen,
+                         p_buffer, sizeof(p_buffer), &ulDataLen);
+ 
+     *p_type = p_buffer[ 4 ] >> 6;
+     *p_mask = p_buffer[ 5 ];
+     *p_scheme = p_buffer[ 6 ];
+ 
  #else
  #   error "DVD ioctls are unavailable on this system"
  
*************** static void QNXInitCPT( CAM_PASS_THRU * 
*** 1733,1735 ****
--- 1884,1914 ----
  }
  #endif
  
+ #if defined( SYS_OS2 )
+ /*****************************************************************************
+  * OS2InitSDC: initialize a SDC structure for the Execute SCSI-command
+  *****************************************************************************
+  * This function initializes a OS2 'execute SCSI command' structure for 
+  * future use, either a read command or a write command.
+  *****************************************************************************/
+ static void OS2InitSDC( struct OS2_ExecSCSICmd *p_sdc, int i_type )
+ {
+     switch( i_type )
+     {
+         case GPCMD_SEND_KEY:
+             p_sdc->flags = 0;
+             break;
+ 
+         case GPCMD_READ_DVD_STRUCTURE:
+         case GPCMD_REPORT_KEY:
+             p_sdc->flags = EX_DIRECTION_IN;
+             break;
+     }
+ 
+     p_sdc->command[ 0 ] = i_type;
+     p_sdc->command[ 8 ] = (p_sdc->data_length >> 8) & 0xff;
+     p_sdc->command[ 9 ] = p_sdc->data_length        & 0xff;
+     p_sdc->id_code      = 0x31304443;    // 'CD01'
+     p_sdc->cmd_length   = 12;
+ }
+ #endif
diff -Nrc3pad libdvdcss/src/ioctl.h libdvdcss.os2/src/ioctl.h
*** libdvdcss/src/ioctl.h	Sun Jun  2 19:14:48 2002
--- libdvdcss.os2/src/ioctl.h	Sat Jun 22 13:40:24 2002
*************** int ioctl_SendKey2          ( int, int *
*** 123,128 ****
--- 123,144 ----
  #endif
  
  /*****************************************************************************
+  * Common macro, OS2 specific
+  *****************************************************************************/
+ #if defined( SYS_OS2 )
+ #define INIT_SSC( TYPE, SIZE ) \
+     struct OS2_ExecSCSICmd sdc; \
+     u8 p_buffer[ (SIZE) ]; \
+     unsigned long ulParamLen; \
+     unsigned long ulDataLen; \
+     memset( &sdc, 0, sizeof( OS2_ExecSCSICmd ) ); \
+     memset( &p_buffer, 0, SIZE ); \
+     sdc.data_length = (SIZE); \
+     ulParamLen = sizeof(sdc); \
+     OS2InitSDC( &sdc, (TYPE) )
+ #endif
+ 
+ /*****************************************************************************
   * Additional types, OpenBSD specific
   *****************************************************************************/
  #if defined( HAVE_OPENBSD_DVD_STRUCT )
*************** typedef union dvd_authinfo dvd_authinfo;
*** 133,139 ****
  /*****************************************************************************
   * Various DVD I/O tables
   *****************************************************************************/
! #if defined( SYS_BEOS ) || defined( WIN32 ) || defined ( SOLARIS_USCSI ) || defined ( HPUX_SCTL_IO ) || defined ( __QNXNTO__ )
      /* The generic packet command opcodes for CD/DVD Logical Units,
       * From Table 57 of the SFF8090 Ver. 3 (Mt. Fuji) draft standard. */
  #   define GPCMD_READ_DVD_STRUCTURE 0xad
--- 149,155 ----
  /*****************************************************************************
   * Various DVD I/O tables
   *****************************************************************************/
! #if defined( SYS_BEOS ) || defined( WIN32 ) || defined ( SOLARIS_USCSI ) || defined ( HPUX_SCTL_IO ) || defined ( __QNXNTO__ ) || defined ( SYS_OS2 )
      /* The generic packet command opcodes for CD/DVD Logical Units,
       * From Table 57 of the SFF8090 Ver. 3 (Mt. Fuji) draft standard. */
  #   define GPCMD_READ_DVD_STRUCTURE 0xad
*************** struct SRB_ExecSCSICmd
*** 309,311 ****
--- 325,352 ----
  
  #endif
  
+ /*****************************************************************************
+  * OS2 ioctl specific
+  *****************************************************************************/
+ #if defined( SYS_OS2 )
+ 
+ #define CDROMDISK_EXECMD      0x7A
+ 
+ #define EX_DIRECTION_IN       0x01
+ #define EX_PLAYING_CHK        0x02
+ 
+ #pragma pack(1)
+ 
+ struct OS2_ExecSCSICmd
+ {
+     unsigned long   id_code;      // 'CD01'
+     unsigned short  data_length;  // length of the Data Packet
+     unsigned short  cmd_length;   // length of the Command Buffer
+     unsigned short  flags;        // flags
+     unsigned char   command[16];  // Command Buffer for SCSI command
+ 
+ } OS2_ExecSCSICmd;
+ 
+ #pragma pack()
+ 
+ #endif
diff -Nrc3pad libdvdcss/src/libdvdcss.c libdvdcss.os2/src/libdvdcss.c
*** libdvdcss/src/libdvdcss.c	Tue Jun  4 10:02:56 2002
--- libdvdcss.os2/src/libdvdcss.c	Sat Jun 22 18:20:28 2002
***************
*** 41,46 ****
--- 41,52 ----
  
  #if defined( WIN32 )
  #   include <io.h>                                                 /* read() */
+ #elif defined( SYS_OS2 )
+ #   define INCL_DOSDEVICES
+ #   define INCL_DOSDEVIOCTL
+ #   define INCL_DOSERRORS
+ #   include <os2.h>
+ #   include <io.h>
  #else
  #   include <sys/uio.h>                                      /* struct iovec */
  #endif
*************** extern dvdcss_handle dvdcss_open ( char 
*** 147,153 ****
  
      char *psz_method = getenv( "DVDCSS_METHOD" );
      char *psz_verbose = getenv( "DVDCSS_VERBOSE" );
! #ifndef WIN32
      char *psz_raw_device = getenv( "DVDCSS_RAW_DEVICE" );
  #endif
  
--- 153,159 ----
  
      char *psz_method = getenv( "DVDCSS_METHOD" );
      char *psz_verbose = getenv( "DVDCSS_VERBOSE" );
! #if !defined ( WIN32 ) && !defined ( SYS_OS2 )
      char *psz_raw_device = getenv( "DVDCSS_RAW_DEVICE" );
  #endif
  
*************** extern dvdcss_handle dvdcss_open ( char 
*** 161,167 ****
      }
  
      /* Initialize structure with default values */
! #ifndef WIN32
      dvdcss->i_raw_fd = -1;
  #endif
      dvdcss->p_titles = NULL;
--- 167,173 ----
      }
  
      /* Initialize structure with default values */
! #if !defined ( WIN32 ) && !defined ( SYS_OS2 )
      dvdcss->i_raw_fd = -1;
  #endif
      dvdcss->p_titles = NULL;
*************** extern dvdcss_handle dvdcss_open ( char 
*** 254,260 ****
          }
      }
  
! #ifndef WIN32
      if( psz_raw_device != NULL )
      {
          _dvdcss_raw_open( dvdcss, psz_raw_device );
--- 260,266 ----
          }
      }
  
! #if !defined ( WIN32 ) && !defined ( SYS_OS2 )
      if( psz_raw_device != NULL )
      {
          _dvdcss_raw_open( dvdcss, psz_raw_device );
*************** extern int dvdcss_read ( dvdcss_handle d
*** 406,412 ****
                  /* or fail completely? return 0; */
  		break;
              }
!             (u8*)p_buffer += DVDCSS_BLOCK_SIZE;
          }
      }
      else 
--- 412,418 ----
                  /* or fail completely? return 0; */
  		break;
              }
!             *(u8*)p_buffer += DVDCSS_BLOCK_SIZE;
          }
      }
      else 
*************** extern int dvdcss_read ( dvdcss_handle d
*** 416,422 ****
  	{
  	    CSSDescrambleSector( dvdcss->css.p_title_key, p_buffer );
  	    ((u8*)p_buffer)[0x14] &= 0x8f;
! 	    (u8*)p_buffer += DVDCSS_BLOCK_SIZE;
  	}
      }
      
--- 422,428 ----
  	{
  	    CSSDescrambleSector( dvdcss->css.p_title_key, p_buffer );
  	    ((u8*)p_buffer)[0x14] &= 0x8f;
! 	    *(u8*)p_buffer += DVDCSS_BLOCK_SIZE;
  	}
      }
      
*************** extern int dvdcss_read ( dvdcss_handle d
*** 426,431 ****
--- 432,438 ----
  /*****************************************************************************
   * dvdcss_readv: read data to an iovec structure, decrypt if requested
   *****************************************************************************/
+ #if !defined ( SYS_OS2 )
  extern int dvdcss_readv ( dvdcss_handle dvdcss, void *p_iovec,
                                                  int i_blocks,
                                                  int i_flags )
*************** extern int dvdcss_readv ( dvdcss_handle 
*** 475,480 ****
--- 482,488 ----
      return i_ret;
  #undef P_IOVEC
  }
+ #endif
  #undef Pkey
  
  /*****************************************************************************
*************** static int _dvdcss_use_ioctls( dvdcss_ha
*** 520,525 ****
--- 528,535 ----
      {
  	return 1;	
      }
+ #elif defined ( SYS_OS2 )
+     return 1;
  #else
      struct stat fileinfo;
      int ret;
*************** static int _dvdcss_open ( dvdcss_handle 
*** 602,607 ****
--- 612,636 ----
      dvdcss->p_readv_buffer   = NULL;
      dvdcss->i_readv_buf_size = 0;
  
+ #elif defined ( SYS_OS2 )
+ 
+     char psz_dvd[4];
+     APIRET rc;
+     ULONG ulAction;
+ 
+     sprintf( psz_dvd, "%c:", psz_target[0] );
+ 
+     rc = DosOpen(psz_dvd, (HFILE *)&dvdcss->i_fd, &ulAction, 0,
+                  FILE_NORMAL, OPEN_ACTION_OPEN_IF_EXISTS,
+                  OPEN_SHARE_DENYNONE | OPEN_ACCESS_READONLY |
+                  OPEN_FLAGS_DASD, NULL);	
+ 
+     if( rc != NO_ERROR )
+     {
+         _dvdcss_error( dvdcss, "failed opening device" );
+         return -1;
+     }
+ 
  #else
      dvdcss->i_fd = dvdcss->i_read_fd = open( psz_target, 0 );
  
*************** static int _dvdcss_close ( dvdcss_handle
*** 655,660 ****
--- 684,705 ----
          dvdcss->i_readv_buf_size = 0;
      }
  
+ #elif defined ( SYS_OS2 )
+ 
+     APIRET rc;
+     ULONG ulParamLen;
+     ULONG ulDataLen;
+     UCHAR ucUnlock;
+ 
+     // Unlock DVD drive door
+     ucUnlock = 0;
+     ulParamLen = 4;
+ 
+     rc = DosDevIOCtl(dvdcss->i_fd, IOCTL_CDROMDISK, CDROMDISK_LOCKUNLOCKDOOR,
+                      "CD01", 4, &ulParamLen, &ucUnlock, sizeof(UCHAR), &ulDataLen);
+ 
+     DosClose( dvdcss->i_fd );
+ 
  #else
      close( dvdcss->i_fd );
  
*************** int _dvdcss_seek ( dvdcss_handle dvdcss,
*** 700,705 ****
--- 745,769 ----
      {
          return ( _win32_dvdcss_aseek( dvdcss->i_fd, i_blocks, SEEK_SET ) );
      }
+ #elif defined ( SYS_OS2 )
+     APIRET rc;
+     LONGLONG i_pos, i_read;
+     long long l_pos;
+ 
+     dvdcss->i_seekpos = i_blocks;
+ 
+     l_pos = (long long)i_blocks * (long long)DVDCSS_BLOCK_SIZE;
+ 
+     i_pos.ulHi = l_pos >> 32;
+     i_pos.ulLo = l_pos & 0xFFFFFFFF;
+ 
+     rc = DosSetFilePtrL(dvdcss->i_fd, i_pos,
+                         FILE_BEGIN, &i_read);
+ 
+     if (rc == NO_ERROR)
+         return dvdcss->i_seekpos;
+     else
+         return -1;
  #else
      off_t   i_read;
  
*************** int _dvdcss_read ( dvdcss_handle dvdcss,
*** 732,738 ****
--- 796,811 ----
      {
          return _win32_dvdcss_aread( dvdcss->i_fd, p_buffer, i_blocks );
      }
+ #elif defined ( SYS_OS2 )
+     ULONG i_bytes;
+ 
+     if( DosRead( dvdcss->i_fd, p_buffer,
+                  (size_t)i_blocks * DVDCSS_BLOCK_SIZE, &i_bytes ) != NO_ERROR)
+     {
+         return -1;
+     }
  
+     return i_bytes / DVDCSS_BLOCK_SIZE;
  #else
      int i_bytes;
      /* TODO: !!! errors are mangled and disarded (-1/2048 = 0)
*************** int _dvdcss_read ( dvdcss_handle dvdcss,
*** 745,750 ****
--- 818,824 ----
  
  }
  
+ #if !defined ( SYS_OS2 )
  static int _dvdcss_readv ( dvdcss_handle dvdcss, struct iovec *p_iovec,
                             int i_blocks )
  {
*************** static int _dvdcss_readv ( dvdcss_handle
*** 780,785 ****
--- 854,860 ----
  #endif
  }
  
+ #endif
  
  #if defined( WIN32 )
  
diff -Nrc3pad libdvdcss/src/libdvdcss.h libdvdcss.os2/src/libdvdcss.h
*** libdvdcss/src/libdvdcss.h	Thu Apr  4 17:21:24 2002
--- libdvdcss.os2/src/libdvdcss.h	Sat Jun 22 17:33:42 2002
*************** int _dvdcss_read  ( dvdcss_handle, void 
*** 68,74 ****
  /*****************************************************************************
   * Error management
   *****************************************************************************/
! #if defined( _WIN32 ) && defined( _MSC_VER )
  #   define DVDCSS_ERROR( x ) fprintf( stderr, "libdvdcss error: %s\n", x );
  #   define DVDCSS_DEBUG( x ) fprintf( stderr, "libdvdcss debug: %s\n", x );
  #else
--- 68,74 ----
  /*****************************************************************************
   * Error management
   *****************************************************************************/
! #if defined( _WIN32 ) && defined( _MSC_VER ) || defined( SYS_OS2 )
  #   define DVDCSS_ERROR( x ) fprintf( stderr, "libdvdcss error: %s\n", x );
  #   define DVDCSS_DEBUG( x ) fprintf( stderr, "libdvdcss debug: %s\n", x );
  #else
